export type DataBaseItem = {
  id: number,
  name: string,
  alias: string,
  groupName: string,
  type: string,
  url: string,
  username: string,
  password: string,
  note: string,
  flinkConfig: string,
  dbVersion: string,
  status: boolean,
  healthTime: Date,
  heartbeatTime: Date,
  enabled: boolean,
  createTime: Date,
  updateTime: Date,
};

export type DataBaseFormProps = {
  name: string,
  alias: string,
  groupName: string,
  type: string,
  ip: string,
  port: number,
  url: string,
  username: string,
  password: string,
  note: string,
  flinkConfig: string,
  dbVersion: string,
  enabled: boolean,
}

export type Column = {
  name: string,
  type: string,
  comment: string,
  keyFlag: boolean,
  autoIncrement: boolean,
  defaultValue: string,
  nullable: string,
  javaType: string,
  columnFamily: string,
  position: number,
  precision: number,
  scale: number,
  characterSet: string,
  collation: string,
};

export type Table = {
  name: string,
  schema: string,
  catalog: string,
  comment: string,
  type: string,
  engine: string,
  options: string,
  rows: number,
  createTime: string,
  updateTime: string,
};
